/* ---------------------------------------------------------------- */
//
// Cache.h
//
// Created by Christoph Birk on 2017-06-01
// Copyright (c) 2017 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Foundation/Foundation.h>

/* ---------------------------------------------------------------- */

@interface CacheObject : NSObject

@property (readonly,nonatomic)  NSArray *array;
@property (readonly,nonatomic)  size_t  size;
@property (readwrite,nonatomic) double  accessTime;

@end

/* ---------------------------------------------------------------- */

@protocol Cache_Delegate
- (NSArray*)cacheLoadKey:(NSString*)key context:(void*)context;
@end

@interface Cache : NSObject
{
}

@property (readwrite,retain,nonatomic) NSString* name;
@property (readwrite,assign,nonatomic) id <Cache_Delegate> delegate;

- (Cache*)initWithCapacity:(u_int)kb forTime:(double)life;
- (NSArray*)loadKey:(NSString*)key context:(void*)context;
- (void)clear;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
