/* ---------------------------------------------------------------- */
//
// SwopeIO.h
// Swope
//
// Created by Christoph Birk on 2013-08-14
// Copyright 2013 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import "Tcpip.h"

/* ---------------------------------------------------------------- */

enum tcs_enum { TCS_OFF,TCS_RPI=1 }; 

enum swope_errors_enum { E_swope_error=E_tcpip_error+200,
  E_swope_notok,
  E_swope_slewing,
  E_swope_focus,
  E_swope_last
};

/* ---------------------------------------------------------------- */

@interface SwopeIO : TCPIP_Connection
{
  int tcs;
}

- (int)getAlpha:(double*)alp delta:(double*)del equinox:(double*)equ;
- (int)offsetRA:(double)dx dec:(double)dy delta:(double)delta;
- (int)moveRA:(double)ra dec:(double)dc equ:(double)eq;
- (int)getAirmass:(float*)am;
- (int)getFocus:(int*)fo;
- (int)setFocus:(int)fo;
- (BOOL)focusMoving;
- (int)focusStop;
- (int)getST:(int*)st;
- (int)getUT:(int*)ut;
- (int)mstat:(double)timeout;
- (int)set_guiding:(BOOL)status;
- (int)stop;

@property (readwrite,copy) NSString *tcsError;  

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
