/* ---------------------------------------------------------------- */
//
// main.h
// Henrietta
//
// Created by Christoph Birk on 2022-09-21
// Copyright © 2022 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#ifndef main_h
#define main_h

#import "Logger.h"

/* ---------------------------------------------------------------- */

#define P_TITLE      "Henrietta" 

#define PROJECT_ID   28              // currently unused
                                     // 1=Magic,2=Max,3=Omega,4=WIRC
                                     // 5=IMACS,6=LDSS,7=PANIC,8=Mike
                                     // 9=RetroCam,10=CDIMM,11=FourStar
                                     // 12=NewCCD,13=BNC,14=CAPS
                                     // 15=MagE,16=PFS,17=DCU,18=M2FS
                                     // 19=Swope,20=duPontM2,21=duPontIMB
                                     // 22=Andor,23=ZWO,24=ADC
                                     // 25=MagGuider(prototype)
                                     // 26=Rotator/Swope,27=GuidePaddle
                                     // 28=Henrietta,29=CSU/MIRMOS

#undef SIM_ONLY                     // Simulator only 

#define LOCALHOST       "localhost"

#define PREFUN       __func__

#if defined(SIM_ONLY) && !defined(NDEBUG)
#define LO_MEM            4    
#else
#define LO_MEM            1
#endif

#ifdef SIM_ONLY
#define DEF_STATE         0
#else
#define DEF_STATE         1
#endif

#define DBE_GALIL_ONLINE  "dbe_galil_online"
#define DBE_GALIL_HOST    "dbe_galil_host"
#define DEF_GALIL_HOST    "10.7.45.143"       // MAC#: 00:50:4c:38:68:81

#define DBE_LAKE_ONLINE   "dbe_lakeshore_online"
#define DBE_LAKE_HOST     "dbe_lakeshore_host"
//#define DEF_LAKE_HOST   "10.7.45.140"       // --> tempcon.xml

#define DBE_TCS_ONLINE    "dbe_tcs_online"
#define DBE_TCS_HOST      "dbe_tcs_host"
#define DEF_TCS_HOST      "10.8.80.53"        // new Swope TCS @ LCO
#define DEF_TCS_PORT      50000

#define REF_PIXELS        4
#define N_CHANNELS        (32/LO_MEM)         // 4CHAN:(/8)

/* ---------------------------------------------------------------- */

extern char   *p_exec,*p_build,*p_version,*p_ident,*r_path,*s_path;
extern BOOL   use_shared;
extern Logger *main_logger;

/* ---------------------------------------------------------------- */

#endif /* main_h */

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
