/* ---------------------------------------------------------------- */
//
// main.m
// Henrietta
//
// Created by Christoph Birk on 2022-05-06
// Copyright © 2022 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#define DEBUG      1

/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

#import "main.h"
#import "MTwister.h"
#import "Yutils.h"

#include "utils.h"

/* ---------------------------------------------------------------- */

char   *p_exec,*p_build,*p_version,*p_ident,*r_path,*s_path;
BOOL   use_shared;
Logger *main_logger;

/* ---------------------------------------------------------------- */
//34567890123456789012345678901234567890

/* ---------------------------------------------------------------- */

int main(int argc, const char * argv[])
{
#if (DEBUG > 0)
  { char buf[128];
#ifdef NDEBUG
    sprintf(buf,"%s: Release",__func__);
#else
    sprintf(buf,"%s: Debug",__func__);
#endif
    if (sizeof(void*) == 8) strcat(buf,"/64-bit");
    assert(sizeof(long) == 8);         // require 64-bit
    assert(sizeof(int) == 4);          // LP64 data model
    fprintf(stderr,"%s\n",buf);
  }
#endif

  p_exec = p_build = p_version = p_ident = r_path = s_path = NULL;
  main_logger = nil;

  return NSApplicationMain(argc, argv);
}

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
