/* ---------------------------------------------------------------- */
//
// GalilHardhat.h
// Swope / Henrietta
//
// Created by Christoph Birk on 2013-07-13
// Copyright 2013 Carnegie Observatories. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

#import "Galil.h"

/* ---------------------------------------------------------------- */

/* ---------------------------------------------------------------- */

@interface GalilHardhat : NSWindowController {
           BOOL        online;
  volatile BOOL        check_open;
  IBOutlet NSButton    *check_A,*check_B,*check_C,*check_D,*check_E;
           NSArray     *check_axis;
  IBOutlet NSTextField *edit_stpA,*edit_stpB,*edit_stpC,*edit_stpD,*edit_stpE;
  IBOutlet NSTextField *edit_relA,*edit_relB,*edit_relC,*edit_relD,*edit_relE;
  IBOutlet NSTextField *edit_velA,*edit_velB,*edit_velC,*edit_velD,*edit_velE;
  IBOutlet NSTextField *edit_spdA,*edit_spdB,*edit_spdC,*edit_spdD,*edit_spdE;
  IBOutlet NSTextField *edit_accA,*edit_accB,*edit_accC,*edit_accD,*edit_accE;
  IBOutlet NSTextField *edit_decA,*edit_decB,*edit_decC,*edit_decD,*edit_decE;
           NSArray     *edit_stp,*edit_rel;
           NSArray     *edit_spd,*edit_acc,*edit_dec,*edit_vel;
  IBOutlet NSButton    *but_relpA,*but_relmA,*but_stopA,*but_clrA;
  IBOutlet NSButton    *but_relpB,*but_relmB,*but_stopB,*but_clrB;
  IBOutlet NSButton    *but_relpC,*but_relmC,*but_stopC,*but_clrC;
  IBOutlet NSButton    *but_relpD,*but_relmD,*but_stopD,*but_clrD;
  IBOutlet NSButton    *but_relpE,*but_relmE,*but_stopE,*but_clrE;
           NSArray     *but_relp,*but_relm,*but_stop,*but_clr;
  IBOutlet NSButton    *but_limfA,*but_limfB,*but_limfC,*but_limfD,*but_limfE;
  IBOutlet NSButton    *but_limrA,*but_limrB,*but_limrC,*but_limrD,*but_limrE;
           NSArray     *but_limf,*but_limr;
  IBOutlet NSSlider    *slider_jogA,*slider_jogB,*slider_jogC,*slider_jogD,*slider_jogE;
           NSArray     *slider_jog;
           int         jog_last;
           NSLock      *jog_lock;
  // logger
  IBOutlet NSTextField *edit_command;
  IBOutlet NSStepper   *step_command;
  IBOutlet NSTableView *messageTable;  
           NSMutableArray  *command_history;
  // wheels
  IBOutlet NSPopUpButton *drop_wheel1,*drop_wheel2,*drop_wheel3,*drop_wheel4;
  IBOutlet NSButton      *but_homs1,*but_homs2,*but_homs3,*but_homs4;
  IBOutlet NSButton      *but_dets1,*but_dets2,*but_dets3,*but_dets4;
  IBOutlet NSButton      *but_home1,*but_home2,*but_home3,*but_home4;
           NSArray       *drop_wheel,*but_dets,*but_homs,*but_home;
}

@property (readonly) int configured;
@property (readonly) NSArray *gAxes,*gWheels; // used by CameraController

+ (NSString*)errorString:(int)err;

- (IBAction)action_check:(id)sender;
- (IBAction)action_update:(id)sender;
- (IBAction)action_edit:(id)sender;
- (IBAction)action_clear:(id)sender;
- (IBAction)action_relative:(id)sender;
- (IBAction)action_stop:(id)sender;
- (IBAction)action_jog:(id)sender;
- (IBAction)action_terminal:(id)sender;
- (IBAction)action_home:(id)sender;

- (void)updateGUI;
-  (int)updateAxis:(int)a fromGalil:(BOOL)refresh;
-  (int)updatePosition:(int)a fromGalil:(BOOL)refresh;
-  (int)updateWheel:(int)f fromGalil:(BOOL)refresh;
- (void)enable:(BOOL)e axis:(int)a;

- (void)run_setup;
- (void)run_waitForAxis:(NSNumber*)axis;
- (void)run_waitForJog:(NSNumber*)axis;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
