/* ---------------------------------------------------------------- */
//
// LakeIO.h
// LakeShore Model 340
//
// Created by Christoph Birk on 2014-09-10
// Copyright (c) 2014 Christoph Birk. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import "Tcpip.h"

/* ---------------------------------------------------------------- */

enum lake_errors_enum { E_lakeio_error = E_tcpip_error+100,
                        E_lakeio_resistor,
                        E_lakeio_lock,
                        E_lakeio_sensor,
                        E_lakeio_last
};

/* ---------------------------------------------------------------- */

@interface LakeIO : TCPIP_Connection {
}

- (int)getVersion:(char*)version;
- (int)setupCurrent:(float)mc resistor:(int)r channel:(int)c;
- (int)setRamp:(float)ramp channel:(int)c;
- (int)setP:(int)p_reg I:(int)i_reg D:(int)d_reg channel:(int)c;
- (int)getP:(int*)p_reg I:(int*)i_reg D:(int*)d_reg channel:(int)c;
- (int)setRange:(int)range channel:(int)c;
- (int)getRange:(int*)range channel:(int)c;
- (int)setSetpoint:(float)setp channel:(int)c;
- (int)getSetpoint:(float*)setp channel:(int)c;
- (int)getPower:(float*)power channel:(int)c;
- (int)getTemp:(float*)temp channel:(int)c;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
