/* ---------------------------------------------------------------- */
//
// TempController.h
// FourStar / Henrietta
//
// Created by Christoph Birk on 2014-09-10
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>


/* ---------------------------------------------------------------- */


/* ---------------------------------------------------------------- */

@interface TempController : NSWindowController {
  int           myid;                  // { 1..TC_N }
  // GUI - Temperature Controller
  IBOutlet NSTextField   *edit_target1,*edit_target2;
  IBOutlet NSTextField   *edit_power1,*edit_power2;
  IBOutlet NSTextField   *edit_setp1,*edit_setp2;
  IBOutlet NSTextField   *edit_ramp1,*edit_ramp2;
  IBOutlet NSPopUpButton *popup_range1,*popup_range2;
           NSArray  *edit_setps,*edit_targets,*edit_ramps,*popup_ranges,*edit_powers;
  // GUI - Temperature Monitor
  IBOutlet NSTextField   *label1,*label2,*label3,*label4;
  IBOutlet NSColorWell   *well1,*well2,*well3,*well4;
  IBOutlet NSButton      *chk_mon1,*chk_mon2,*chk_mon3,*chk_mon4;
  IBOutlet NSTextField   *edit_temp1,*edit_temp2,*edit_temp3,*edit_temp4;
  IBOutlet NSTextField   *edit_grad1,*edit_grad2,*edit_grad3,*edit_grad4;
           NSArray       *chk_mons,*edit_temps,*edit_grads;
  // Panel - Tune parameters
  IBOutlet NSPanel *panel_tune;
  IBOutlet NSTextField *edit_p,*edit_i,*edit_d;
}

@property (atomic)        BOOL  stop_reading; 

+ (NSString*)defaultHost;
+ (NSString*)errorString:(int)err;

- (id)initWithWindowNib:(NSString*)file;

- (void)action_menu:(id)sender;

- (IBAction)action_setp:(id)sender;
- (IBAction)action_range:(id)sender;
- (IBAction)action_ramp:(id)sender;
- (IBAction)action_tune:(id)sender;
- (IBAction)action_check:(id)sender;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
