#!/usr/bin/env python3
from serial import Serial
import time

def init():
    a=Serial('COM4',timeout=.5,baudrate=115200)

    #a.write(b'TH;\r\n')

    #print(a.read(1000))

    #a.close()
    return a

def mv(A,d,fd):
    a = init()
    a.write(b'MT 2,2,2,2,2;AG 2,2,2,2,2;SP 2500,2500,2500,2500,2500;LC 2,2,2,2,2;CN 1;SH\r\n')

    print('first write')
    print(a.read(1000000))
    a.write(f'LD{A}=3;JG{A}={d}2500;BG{A}\r\n'.encode('utf-8'))
    print(a.read(1000000))
    time.sleep(1)
    a.write(f'LD{A}=0\r\n'.encode('utf-8'));
    print(a.read(1000000))
    t = time.strftime('%x %X')
    a.write(f'MG _LF{A},_LR{A},_HM{A},_PA{A}\r\n'.encode('utf-8'))
    bf = a.read(100000).decode('utf-8').split('\r\n')[-2].strip()
    bf = bf.split(' ')
    bf0 = f'{t},{A},{bf[0]},{bf[1]},{bf[2]},{bf[3]}\r\n'
    print(bf0)
    fp = open(fd,'a')
    fp.write(bf0)
    fp.close()
    while True:
        a.write(f'MG _BG{A}\r\n'.encode('utf-8'))
        bf = a.read(1000000).split(b'\r\n')[-2]
        bf = int(float(bf))
        if bf == 0:break
        time.sleep(1)
    a.write(f'ST;MG _LF{A},_LR{A},_HM{A},_PA{A}\r\n'.encode('utf-8'))
    bf = a.read(100000).decode('utf-8').split('\r\n')[-2].strip()
    bf = bf.split(' ')
    bf0 = f'{t},{A},{bf[0]},{bf[1]},{bf[2]},{bf[3]}\r\n'
    a.close();
    print(bf0)
    fp = open(fd,'a')
    fp.write(bf0)
    fp.close()

def get_temp(a):
    a.write(b'KRDG? 0\r\n')
    t = a.read(100000)
    return t.strip().decode('utf-8')

def get_pressure(a):
    a.write(b"MG @AN[8]\r\n")
    p = a.read(10000)
    print(p)
    p = float(p.split()[-2])
    #p = 10**(p-10)
    p = 10**(1.667*p-11.46)
    return p


def loop(fd='./test1.dat'):
    a = init()

    ct = 0
    while ct <= 100:

    
    	t = time.strftime('%x %X')
    	p = get_pressure(a)
    	
    	fp = open(fd,'a')
    	fp.write(f'{t},{p}\r\n')

    
    	ct += 1

    	time.sleep(10)

    a.close()
    fp.close()

def mloop():
    fd = './test.dat'
    #axis = ('B','A','C','D','E')

    axis = ('B','B')
    #axis = ('A','C','D','E')
    for i in range(1):
        j = 0
        cnt = 0
        while j < len(axis):
            try:
                mv(axis[j],'-',fd);j+=1
            except Exception as x: print(x);cnt+=1

if __name__ == "__main__":

    mloop()
